; MAKEALL LINKALL CONSOLE DEBUG !CLEAN 
; 

    M32FOLDER TEXTEQU <\masm32>

   %include    M32FOLDER&\\INCLUDE\\ASMRT.inc

   %includelib M32FOLDER&\\LIB\\ASMRT.lib


    include LinkedList.inc
    
; 
    .data
        lpList  DWORD   0
        
        Item    DWORD   0, 0
        ItemMask DWORD  -1, -1

    .code

Main PROC
    ConsoleInit
    
    invoke  List_Create, 0, 8, 4
    mov     lpList, eax
    Print   "lpList = %8Hh\n\n", lpList
    
    
    mov     esi, CInput("Type something: ")
    mov     edi, CInput("Type something else: ")
    
    mov     Item, esi
    mov     Item[4], 1
    invoke  List_Add, lpList, OFFSET Item
    mov     Item, edi
    mov     Item[4], 2
    invoke  List_Add, lpList, OFFSET Item
    
    invoke  List_Get, lpList, 1
    mov     eax, [eax]
    Print   "Item 1: (%8Hh) = %[s]\n", eax, eax
    invoke  List_Get, lpList, 2
    mov     eax, [eax]
    Print   "Item 2: (%8Hh) = %[s]\n", eax, eax
    
    mov     eax, lpList
    mov     eax, [eax+4]
    .while(DWORD PTR [eax] != -1)
        Print   "Entry: State = %4H Data1 = %8H Data2 = %8H\n", DWORD PTR [eax], DWORD PTR [eax+4], DWORD PTR [eax+8]
        add     eax, 8+4
    .endw
    CPrintLn
    
    mov     Item[0], 0
    mov     Item[4], 1
    mov     ItemMask[0], 0
    mov     ItemMask[4], -1
    invoke  List_Find, lpList, 1, OFFSET Item, OFFSET ItemMask
    Print   "Found Entry %d\n", eax

    mov     Item[0], esi
    mov     Item[4], 2
    mov     ItemMask[0], -1
    mov     ItemMask[4], 0
    invoke  List_Find, lpList, 1, OFFSET Item, OFFSET ItemMask
    Print   "Found Entry %d\n", eax
    
    
    CPause
    
    ret
Main ENDP

; 
END _ENTRY
